const DownloadScheduler = require("./downloadScheduler");

process.parentPort.on("message", (e) => {
    const result = Promise.resolve(handlers[e.data.type](...e.data.args));

    if (e.data.callbackId) {
        result.then((r) => process.parentPort.postMessage({ eventType: e.data.callbackId, args: [r] }));
    }
});

let downloadScheduler = DownloadScheduler.getInstance();

downloadScheduler.on("*", (e) => {
    process.parentPort.postMessage(e);
});

const handlers = {
    async startDownload(applicationsDownloadingInfo) {
        await downloadScheduler.createDownloaders(applicationsDownloadingInfo);
        downloadScheduler.start();
    },
    stop() {
        return downloadScheduler.stop();
    },
};

process.on("uncaughtException", (error) => {
    process.parentPort.postMessage({ eventType: "uncaughtException", args: [error] });
});
