'use strict';

const { shell } = require('electron');

const path = require('path');

const $ = require('jquery');
require('datatables.net')(window, $);

let tableOfApplications;

function addApplications(applications) {
    tableOfApplications = $('#applications').dataTable({
        data: applications,
        columns: [
            {data: 'code'},
            {data: 'category'},
            {data: 'applicationTitle'},
            {data: 'downloadedFilesInfo'}
        ],
        columnDefs: [
            {
                targets: 3,
                orderable: false,
                render: function (filesInfo) {
                    return filesInfo.map((fileInfo) => {
                        return '<a id="' + fileInfo.path + '" href="#" onclick="openFile(this)">' + fileInfo.name + '</a>' + '<br/>';
                    }).join('');
                }
            }],
        createdRow: function(newRow, app) {
            newRow.dataset.applicationCode = app.code;
        }
    }).api();
}

function openFile(linkFileInfo) {
    shell.openItem(linkFileInfo.id);
    return false;
}

function addFileToApplication(fileInfo, applicationCode) {
    let row = tableOfApplications.row('[data-application-code="' + applicationCode + '"]');
    let application = row.data();
    application.downloadedFilesInfo.push(fileInfo);
    row.data(application);
}
